-- DESCRIPTION: OneShot (Single Pulse) output circuit.
--              the output will go high for only one clk cycle

-- Designer: Cristos Zamantzas
-- Version: 5
-- Date: 03/04/2006

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.all;
USE IEEE.STD_LOGIC_UNSIGNED.all;

ENTITY OnePulse IS
   
   PORT(
        Din, 
        clk  : IN  STD_LOGIC;
        SP   : OUT STD_LOGIC
        );

END OnePulse;

ARCHITECTURE RTL OF onepulse IS

SIGNAL Din_delay : STD_LOGIC;

BEGIN
 PROCESS (clk)
 BEGIN
    IF  rising_edge(clk) THEN
        IF Din = '1' AND Din_delay = '0' THEN
            SP <= '1';
        ELSE
            SP <= '0';
        END IF;
    Din_delay <= Din;
   END IF;
 END PROCESS;
END RTL;
