----------------------------------------------------------
-- File:          max_21bit.vhd 
-- Description:   Max values of the input
-- Designer:      Christos Zamantzas
-- Date:          04/02/2005 rev.5
----------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY Max_22bit IS 
   port
   (
      clk :  IN  STD_LOGIC;
      reset :  IN  STD_LOGIC;
      enable :  IN  STD_LOGIC;
      data :  IN  STD_LOGIC_VECTOR(21 downto 0);
      max :  OUT  STD_LOGIC_VECTOR(21 downto 0)
   );
END Max_22bit;

ARCHITECTURE Structure OF Max_22bit IS 

component max_compare_22bits
   PORT(dataa : IN STD_LOGIC_VECTOR(21 downto 0);
       datab : IN STD_LOGIC_VECTOR(21 downto 0);
       agb : OUT STD_LOGIC
   );
end component;

signal   en_max :  STD_LOGIC;
signal   greater :  STD_LOGIC;
signal   max_int :  STD_LOGIC_VECTOR(21 downto 0);

BEGIN 

instmax22 : max_compare_22bits
PORT MAP(dataa => data,
       datab => max_int,
       agb => greater);


process(clk,reset)
begin
if (reset = '1') then
   max_int <= (others => '0'); 

elsif (rising_edge(clk)) then
   if (en_max = '1') then
   max_int <= data;
   end if;
end if;
end process;

en_max <= greater AND enable;


max <= max_int;

END; 